Index: /trunk/include/regfi.h
===================================================================
--- /trunk/include/regfi.h	(revision 167)
+++ /trunk/include/regfi.h	(revision 168)
@@ -631,224 +687,216 @@
 
 
-/* regfi_iterator_free: Frees a registry file iterator previously created by 
- *                      regfi_iterator_new.
+/** Frees a registry file iterator previously created by regfi_iterator_new.
  *
  * This does not affect the underlying registry file's allocation status.
  *
- * Arguments:
- *   file            -- the iterator to be freed
+ * @param i the iterator to be freed
+ *
+ * @ingroup regfiTopLayer
  */
 void                  regfi_iterator_free(REGFI_ITERATOR* i);
 
 
-/* regfi_iterator_down: Traverse deeper into the registry tree at the
- *                      current subkey.
- *
- * Arguments:
- *   i            -- the iterator
- *
- * Returns:
- *   true on success, false on failure.  Note that subkey and value indexes
- *   are preserved.  That is, if a regfi_iterator_up call occurs later
- *   (reversing the effect of this call) then the subkey and value referenced
- *   prior to the regfi_iterator_down call will still be referenced.  This 
- *   makes depth-first iteration particularly easy.
+/** Traverse deeper into the registry tree at the current subkey.
+ *
+ * @param i the iterator
+ *
+ * @return  true on success, false on failure.  
+ *          Note that subkey and value indexes are preserved.  That is, if a
+ *          regfi_iterator_up call occurs later (reversing the effect of this
+ *          call) then the subkey and value referenced prior to the
+ *          regfi_iterator_down call will still be referenced.  This  makes
+ *          depth-first iteration particularly easy.
+ *
+ * @ingroup regfiTopLayer
  */
 bool                  regfi_iterator_down(REGFI_ITERATOR* i);
 
 
-/* regfi_iterator_up: Traverse up to the current key's parent key.
- *
- * Arguments:
- *   i            -- the iterator
- *
- * Returns:
- *   true on success, false on failure.  Any subkey or value state
- *   associated with the current key is lost.
+/** Traverse up to the current key's parent key.
+ *
+ * @param i the iterator
+ *
+ * @return  true on success, false on failure.  Any subkey or value state
+ *          associated with the current key is lost.
+ *
+ * @ingroup regfiTopLayer
  */
 bool                  regfi_iterator_up(REGFI_ITERATOR* i);
 
 
-/* regfi_iterator_to_root: Traverse up to the root key of the hive.
- *
- * Arguments:
- *   i            -- the iterator
- *
- * Returns:
- *   true on success, false on failure.
+/** Traverse up to the root key of the hive.
+ *
+ * @param i the iterator
+ *
+ * @return true on success, false on failure.
+ *
+ * @ingroup regfiTopLayer
  */
 bool                  regfi_iterator_to_root(REGFI_ITERATOR* i);
 
 
-/* regfi_iterator_walk_path: Traverse down multiple levels in the registry hive.
- *
- * Arguments:
- *   i            -- the iterator
- *   path         -- a list of key names representing the path.  This list must
- *                   contain NUL terminated strings.  The list itself is
- *                   terminated with a NULL pointer.  All path elements must be
- *                   keys; value names are not accepted (even as the last
- *                   element).
+/** Traverse down multiple levels in the registry hive.
  *
  * XXX: This currently only accepts ASCII key names.  Need to look into
  *      accepting other encodings.
  *
- * Returns:
- *   true on success, false on failure.  If any element of path is not found,
- *   false will be returned and the iterator will remain in its original
- *   position.
- */
-bool                  regfi_iterator_walk_path(REGFI_ITERATOR* i, 
-					       const char** path);
-
-
-/* regfi_iterator_cur_key: Returns the currently referenced key.
- *
- * Arguments:
- *   i            -- the iterator
- *
- * Returns:
- *   A read-only key structure for the current key, or NULL on failure.
+ * @param i    the iterator
+ * @param path a list of key names representing the path.  This list must
+ *             contain NUL terminated strings.  The list itself is
+ *             terminated with a NULL pointer.  All path elements must be
+ *             keys; value names are not accepted (even as the last
+ *             element).
+ *
+ * @return true on success, false on failure.  If any element of path is not
+ *                 found, false will be returned and the iterator will remain
+ *                 in its original position.
+ *
+ * @ingroup regfiTopLayer
+ */
+bool regfi_iterator_walk_path(REGFI_ITERATOR* i, const char** path);
+
+
+/** Returns the currently referenced key.
+ *
+ * @param i the iterator
+ *
+ * @return A read-only key structure for the current key, or NULL on failure.
+ *
+ * @ingroup regfiTopLayer
  */
 const REGFI_NK_REC*   regfi_iterator_cur_key(REGFI_ITERATOR* i);
 
 
-/* regfi_iterator_cur_sk: Returns the SK (security) record referenced by the 
- *                        current key.
- *
- * Arguments:
- *   i            -- the iterator
- *
- * Returns:
- *   A read-only SK structure, or NULL on failure.
+/** Returns the SK (security) record referenced by the current key.
+ *
+ * @param i the iterator
+ *
+ * @return A read-only SK structure, or NULL on failure.
+ *
+ * @ingroup regfiTopLayer
  */
 const REGFI_SK_REC*   regfi_iterator_cur_sk(REGFI_ITERATOR* i);
 
 
-/* regfi_iterator_first_subkey: Sets the internal subkey index to the first
- *                              subkey referenced by the current key and returns
- *                              that key.
- *
- * Arguments:
- *   i            -- the iterator
- *
- * Returns:
- *   A newly allocated key structure for the newly referenced first subkey, or
- *   NULL on failure.  Failure may be due to a lack of any subkeys or other
- *   errors.  Newly allocated keys must be freed with regfi_free_key.
+/** Sets the internal subkey index to the first subkey referenced by the current
+ *  key and returns that key.
+ *
+ * @param i the iterator
+ *
+ * @return A newly allocated key structure for the newly referenced first 
+ *         subkey, or NULL on failure.  Failure may be due to a lack of any
+ *         subkeys or other errors.  Newly allocated keys must be freed with
+ *         regfi_free_key.
+ *
+ * @ingroup regfiTopLayer
  */
 REGFI_NK_REC*         regfi_iterator_first_subkey(REGFI_ITERATOR* i);
 
 
-/* regfi_iterator_cur_subkey: Returns the currently indexed subkey.
- *
- * Arguments:
- *   i            -- the iterator
- *
- * Returns:
- *   A newly allocated key structure for the currently referenced subkey,
- *   or NULL on failure.  Newly allocated keys must be freed with 
- *   regfi_free_key.
+/** Returns the currently indexed subkey.
+ *
+ * @param i the iterator
+ *
+ * @return A newly allocated key structure for the currently referenced subkey,
+ *         or NULL on failure.  Newly allocated keys must be freed with 
+ *         regfi_free_key.
+ *
+ * @ingroup regfiTopLayer
  */
 REGFI_NK_REC*         regfi_iterator_cur_subkey(REGFI_ITERATOR* i);
 
 
-/* regfi_iterator_next_subkey: Increments the internal subkey index to the next
- *                             key in the subkey-list and returns the subkey
- *                             for that index.
- *
- * Arguments:
- *   i            -- the iterator
- *
- * Returns:
- *   A newly allocated key structure for the next subkey or NULL on
- *   failure.  Newly allocated keys must be freed with
- *   regfi_free_key.
+/** Increments the internal subkey index to the next key in the subkey-list and
+ *  returns the subkey for that index.
+ *
+ * @param i the iterator
+ *
+ * @return A newly allocated key structure for the next subkey or NULL on
+ *         failure.  Newly allocated keys must be freed with regfi_free_key.
+ *
+ * @ingroup regfiTopLayer
  */
 REGFI_NK_REC*         regfi_iterator_next_subkey(REGFI_ITERATOR* i);
 
 
-/* regfi_iterator_find_subkey: Searches for a subkey with a given name under the
- *                             current key.
- *
- * Arguments:
- *   i            -- the iterator
- *   subkey_name  -- subkey name to search for
- *
- * Returns:
- *   True if such a subkey was found, false otherwise.  If a subkey is found,
- *   the current subkey index is set to that subkey.  Otherwise, the subkey
- *   index remains at the same location as before the call.
+/** Searches for a subkey with a given name under the current key.
+ *
+ * @param i           the iterator
+ * @param subkey_name subkey name to search for
+ *
+ * @return True if such a subkey was found, false otherwise.  If a subkey is
+ *         found, the current subkey index is set to that subkey.  Otherwise,
+ *         the subkey index remains at the same location as before the call.
+ *
+ * @ingroup regfiTopLayer
  */
 bool                  regfi_iterator_find_subkey(REGFI_ITERATOR* i, 
 						 const char* subkey_name);
 
-/* regfi_iterator_first_value: Sets the internal value index to the first
- *                             value referenced by the current key and returns
- *                             that value.
- *
- * Arguments:
- *   i            -- the iterator
- *
- * Returns:
- *   A newly allocated value structure for the newly referenced first value, 
- *   or NULL on failure.  Failure may be due to a lack of any values or other
- *   errors.  Newly allocated keys must be freed with regfi_free_value.
+/** Sets the internal value index to the first value referenced by the current
+ *  key and returns that value.
+ *
+ * @param i the iterator
+ *
+ * @return  A newly allocated value structure for the newly referenced first
+ *          value, or NULL on failure.  Failure may be due to a lack of any
+ *          values or other errors.  Newly allocated keys must be freed with
+ *          regfi_free_value.
+ *
+ * @ingroup regfiTopLayer
  */
 REGFI_VK_REC*         regfi_iterator_first_value(REGFI_ITERATOR* i);
 
 
-/* regfi_iterator_cur_value: Returns the currently indexed value.
- *
- * Arguments:
- *   i            -- the iterator
- *
- * Returns:
- *   A newly allocated value structure for the currently referenced value, 
- *   or NULL on failure.  Newly allocated values must be freed with 
- *   regfi_free_value.
+/** Returns the currently indexed value.
+ *
+ * @param i the iterator
+ *
+ * @return A newly allocated value structure for the currently referenced value,
+ *         or NULL on failure.  Newly allocated values must be freed with 
+ *         regfi_free_value.
+ *
+ * @ingroup regfiTopLayer
  */
 REGFI_VK_REC*         regfi_iterator_cur_value(REGFI_ITERATOR* i);
 
 
-/* regfi_iterator_next_value: Increments the internal value index to the next
- *                            value in the value-list and returns the value
- *                            for that index.
- *
- * Arguments:
- *   i            -- the iterator
- *
- * Returns:
- *   A newly allocated key structure for the next value or NULL on failure.
- *   Newly allocated keys must be freed with regfi_free_value.
+/** Increments the internal value index to the next value in the value-list and
+ *  returns the value for that index.
+ *
+ * @param i the iterator
+ *
+ * @return  A newly allocated key structure for the next value or NULL on 
+ *          failure.  Newly allocated keys must be freed with regfi_free_value.
+ *
+ * @ingroup regfiTopLayer
  */
 REGFI_VK_REC*         regfi_iterator_next_value(REGFI_ITERATOR* i);
 
 
-/* regfi_iterator_find_value: Searches for a value with a given name under the
- *                            current key.
- *
- * Arguments:
- *   i            -- the iterator
- *   value_name   -- value name to search for
- *
- * Returns:
- *   True if such a value was found, false otherwise.  If a value is found,
- *   the current value index is set to that value.  Otherwise, the value
- *   index remains at the same location as before the call.
+/** Searches for a value with a given name under the current key.
+ *
+ * @param i          the iterator
+ * @param value_name value name to search for
+ *
+ * @return True if such a value was found, false otherwise.  If a value is 
+ *         found, the current value index is set to that value.  Otherwise,
+ *         the value index remains at the same location as before the call.
+ *
+ * @ingroup regfiTopLayer
  */
 bool                  regfi_iterator_find_value(REGFI_ITERATOR* i, 
 						const char* value_name);
 
-
-/* regfi_iterator_fetch_classname: Retrieves classname for a given key.
- *
- * Arguments:
- *   i            -- the iterator
- *   key          -- the key whose classname is desired
- *
- * Returns:
- *   Returns a newly allocated classname structure, or NULL on failure.
- *   Classname structures must be freed with regfi_free_classname.
+/** Retrieves classname for a given key.
+ *
+ * @param i   the iterator
+ * @param key the key whose classname is desired
+ *
+ * @return Returns a newly allocated classname structure, or NULL on failure.
+ *         Classname structures must be freed with regfi_free_classname.
+ *
+ * @ingroup regfiTopLayer
  */
 REGFI_CLASSNAME*      regfi_iterator_fetch_classname(REGFI_ITERATOR* i, 
@@ -856,13 +904,13 @@
 
 
-/* regfi_iterator_fetch_data: Retrieves data for a given value.
- *
- * Arguments:
- *   i            -- the iterator
- *   value        -- the value whose data is desired
- *
- * Returns:
- *   Returns a newly allocated data structure, or NULL on failure.
- *   Data structures must be freed with regfi_free_data.
+/** Retrieves data for a given value.
+ *
+ * @param i     the iterator
+ * @param value the value whose data is desired
+ *
+ * @return Returns a newly allocated data structure, or NULL on failure.
+ *         Data structures must be freed with regfi_free_data.
+ *
+ * @ingroup regfiTopLayer
  */
 REGFI_DATA*           regfi_iterator_fetch_data(REGFI_ITERATOR* i, 
@@ -870,102 +918,250 @@
 
 
-/********************************************************/
-/* Middle-layer structure loading, linking, and caching */
-/********************************************************/
-REGFI_NK_REC*         regfi_load_key(REGFI_FILE* file, uint32 offset, 
+
+/******************************************************************************/
+/** 
+ * @defgroup regfiMiddleLayer Middle Layer: Logical Data Structure Loading 
+ */
+/******************************************************************************/
+
+/** Loads a key at a given file offset along with associated data structures.
+ *
+ * XXX: finish documenting
+ *
+ * @ingroup regfiMiddleLayer
+ */
+REGFI_NK_REC*         regfi_load_key(REGFI_FILE* file, uint32_t offset, 
 				     REGFI_ENCODING output_encoding, 
 				     bool strict);
-REGFI_VK_REC*         regfi_load_value(REGFI_FILE* file, uint32 offset, 
+
+
+/** Loads a value at a given file offset alng with associated data structures.
+ *
+ * XXX: finish documenting
+ *
+ * @ingroup regfiMiddleLayer
+ */
+REGFI_VK_REC*         regfi_load_value(REGFI_FILE* file, uint32_t offset, 
 				       REGFI_ENCODING output_encoding, 
 				       bool strict);
-REGFI_SUBKEY_LIST*    regfi_load_subkeylist(REGFI_FILE* file, uint32 offset,
-					    uint32 num_keys, uint32 max_size,
+
+
+/** Loads a logical subkey list in its entirety which may span multiple records.
+ *
+ * XXX: finish documenting
+ *
+ * @ingroup regfiMiddleLayer
+ */
+REGFI_SUBKEY_LIST*    regfi_load_subkeylist(REGFI_FILE* file, uint32_t offset,
+					    uint32_t num_keys, uint32_t max_size,
 					    bool strict);
-REGFI_VALUE_LIST*     regfi_load_valuelist(REGFI_FILE* file, uint32 offset, 
-					   uint32 num_values, uint32 max_size,
+
+
+/** Loads a valuelist.
+ *
+ * XXX: finish documenting
+ *
+ * @ingroup regfiMiddleLayer
+ */
+REGFI_VALUE_LIST*     regfi_load_valuelist(REGFI_FILE* file, uint32_t offset, 
+					   uint32_t num_values, uint32_t max_size,
 					   bool strict);
 
-REGFI_BUFFER          regfi_load_data(REGFI_FILE* file, uint32 voffset,
-				      uint32 length, bool data_in_offset,
+
+/** Loads a data record which may be contained in the virtual offset, in a
+ *  single cell, or in multiple cells through big data records.
+ *
+ * XXX: finish documenting
+ *
+ * @ingroup regfiMiddleLayer
+ */
+REGFI_BUFFER          regfi_load_data(REGFI_FILE* file, uint32_t voffset,
+				      uint32_t length, bool data_in_offset,
 				      bool strict);
 
-REGFI_BUFFER          regfi_load_big_data(REGFI_FILE* file, uint32 offset, 
-					  uint32 data_length,uint32 cell_length,
+
+/** Loads the data associated with a big data record at the specified offset.
+ *
+ * XXX: finish documenting
+ *
+ * @ingroup regfiMiddleLayer
+ */
+REGFI_BUFFER          regfi_load_big_data(REGFI_FILE* file, uint32_t offset, 
+					  uint32_t data_length,uint32_t cell_length,
 					  range_list* used_ranges,
 					  bool strict);
+
+
+/** Given raw data, attempts to interpret the data based on a specified registry
+ *  data type.
+ *
+ * XXX: finish documenting
+ *
+ * @ingroup regfiMiddleLayer
+ */
 bool                  regfi_interpret_data(REGFI_FILE* file, 
 					   REGFI_ENCODING string_encoding,
-					   uint32 type, REGFI_DATA* data);
+					   uint32_t type, REGFI_DATA* data);
+
+
+/** Frees the memory associated with a REGFI_CLASSNAME data structure.
+ *
+ * XXX: finish documenting
+ *
+ * @ingroup regfiMiddleLayer
+ */
 void                  regfi_free_classname(REGFI_CLASSNAME* classname);
+
+
+/** Frees the memory associated with a REGFI_DATA data structure.
+ *
+ * XXX: finish documenting
+ *
+ * @ingroup regfiMiddleLayer
+ */
 void                  regfi_free_data(REGFI_DATA* data);
 
 
 /* These are cached so return values don't need to be freed. */
-const REGFI_SK_REC*   regfi_load_sk(REGFI_FILE* file, uint32 offset,
+
+/** Loads an "sk" security record at the specified offset.
+ *
+ * XXX: finish documenting
+ *
+ * @ingroup regfiMiddleLayer
+ */
+const REGFI_SK_REC*   regfi_load_sk(REGFI_FILE* file, uint32_t offset,
 				    bool strict);
-const REGFI_HBIN*     regfi_lookup_hbin(REGFI_FILE* file, uint32 offset);
-
-
-/************************************/
-/*  Low-layer data structure access */
-/************************************/
+
+
+/** Retrieves the HBIN data structure stored at the specified offset.
+ *
+ * XXX: finish documenting
+ *
+ * @ingroup regfiMiddleLayer
+ */
+const REGFI_HBIN*     regfi_lookup_hbin(REGFI_FILE* file, uint32_t offset);
+
+
+
+/******************************************************************************/
+/**
+ * @defgroup regfiBottomLayer Bottom Layer: Direct Data Structure Access 
+ */
+/******************************************************************************/
+
 REGFI_FILE*           regfi_parse_regf(int fd, bool strict);
-REGFI_HBIN*           regfi_parse_hbin(REGFI_FILE* file, uint32 offset, 
+REGFI_HBIN*           regfi_parse_hbin(REGFI_FILE* file, uint32_t offset, 
 				       bool strict);
 
 
-/* regfi_parse_nk: Parses an NK record.
- *
- * Arguments:
- *   f        -- the registry file structure
- *   offset   -- the offset of the cell (not the record) to be parsed.
- *   max_size -- the maximum size the NK cell could be. (for validation)
- *   strict   -- if true, rejects any malformed records.  Otherwise,
- *               tries to minimally validate integrity.
- * Returns:
- *   A newly allocated NK record structure, or NULL on failure.
- */
-REGFI_NK_REC*         regfi_parse_nk(REGFI_FILE* file, uint32 offset,
-				     uint32 max_size, bool strict);
-
-REGFI_SUBKEY_LIST*    regfi_parse_subkeylist(REGFI_FILE* file, uint32 offset,
-					     uint32 max_size, bool strict);
-
-REGFI_VK_REC*         regfi_parse_vk(REGFI_FILE* file, uint32 offset, 
-				     uint32 max_size, bool strict);
-
-REGFI_SK_REC*         regfi_parse_sk(REGFI_FILE* file, uint32 offset, 
-				     uint32 max_size, bool strict);
-
+/** Parses an NK record at the specified offset
+ *
+ * @param file     the registry file structure
+ * @param offset   the offset of the cell (not the record) to be parsed.
+ * @param max_size the maximum size the NK cell could be. (for validation)
+ * @param strict   if true, rejects any malformed records.  Otherwise,
+ *                 tries to minimally validate integrity.
+ *
+ * @return A newly allocated NK record structure, or NULL on failure.
+ *
+ * @ingroup regfiBottomLayer
+ */
+REGFI_NK_REC*         regfi_parse_nk(REGFI_FILE* file, uint32_t offset,
+				     uint32_t max_size, bool strict);
+
+
+/** Parses a single cell containing a subkey-list record.
+ *
+ * XXX: finish documenting
+ *
+ * @ingroup regfiBottomLayer
+ */
+REGFI_SUBKEY_LIST*    regfi_parse_subkeylist(REGFI_FILE* file, uint32_t offset,
+					     uint32_t max_size, bool strict);
+
+
+/** Parses a VK (value) record at the specified offset
+ *
+ * XXX: finish documenting
+ *
+ * @ingroup regfiBottomLayer
+ */
+REGFI_VK_REC*         regfi_parse_vk(REGFI_FILE* file, uint32_t offset, 
+				     uint32_t max_size, bool strict);
+
+
+/** Parses an SK (security) record at the specified offset
+ *
+ * XXX: finish documenting
+ *
+ * @ingroup regfiBottomLayer
+ */
+REGFI_SK_REC*         regfi_parse_sk(REGFI_FILE* file, uint32_t offset, 
+				     uint32_t max_size, bool strict);
+
+
+/** Retrieves information on all cells in the registry hive which are 
+ *  currently in the unallocated status.  
+ *
+ * The unallocated status is determined based soley on the cell length sign.
+ *
+ * XXX: finish documenting
+ *
+ * @ingroup regfiBottomLayer
+ */
 range_list*           regfi_parse_unalloc_cells(REGFI_FILE* file);
 
-bool                  regfi_parse_cell(int fd, uint32 offset, 
-				       uint8* hdr, uint32 hdr_len,
-				       uint32* cell_length, bool* unalloc);
-
-uint8*                regfi_parse_classname(REGFI_FILE* file, uint32 offset,
-					    uint16* name_length, 
-					    uint32 max_size, bool strict);
-
-REGFI_BUFFER          regfi_parse_data(REGFI_FILE* file, uint32 offset,
-				       uint32 length, bool strict);
-
-REGFI_BUFFER          regfi_parse_little_data(REGFI_FILE* file, uint32 voffset, 
-					      uint32 length, bool strict);
-
-
-/* Dispose of previously parsed records */
-void                  regfi_free_key(REGFI_NK_REC* nk);
-void                  regfi_free_value(REGFI_VK_REC* vk);
-
-
-
-/************************************/
-/*    Private Functions             */
-/************************************/
+
+/** Helper function to parse a cell
+ *
+ * XXX: finish documenting
+ *
+ * @ingroup regfiBottomLayer
+ */
+bool                  regfi_parse_cell(int fd, uint32_t offset, 
+				       uint8_t* hdr, uint32_t hdr_len,
+				       uint32_t* cell_length, bool* unalloc);
+
+
+/** Parses a classname cell
+ *
+ * XXX: finish documenting
+ *
+ * @ingroup regfiBottomLayer
+ */
+uint8_t*                regfi_parse_classname(REGFI_FILE* file, uint32_t offset,
+					    uint16_t* name_length, 
+					    uint32_t max_size, bool strict);
+
+
+/** Parses a single-cell data record
+ *
+ * XXX: finish documenting
+ *
+ * @ingroup regfiBottomLayer
+ */
+REGFI_BUFFER          regfi_parse_data(REGFI_FILE* file, uint32_t offset,
+				       uint32_t length, bool strict);
+
+
+/** Parses a "little data" record which is stored entirely within the 
+ *  provided virtual offset.
+ *
+ * XXX: finish documenting
+ *
+ * @ingroup regfiBottomLayer
+ */
+REGFI_BUFFER          regfi_parse_little_data(REGFI_FILE* file, uint32_t voffset, 
+					      uint32_t length, bool strict);
+
+
+/******************************************************************************/
+/*    Private Functions                                                       */
+/******************************************************************************/
 REGFI_NK_REC*         regfi_rootkey(REGFI_FILE* file, 
 				    REGFI_ENCODING output_encoding);
 void                  regfi_subkeylist_free(REGFI_SUBKEY_LIST* list);
-uint32                regfi_read(int fd, uint8* buf, uint32* length);
+uint32_t                regfi_read(int fd, uint8_t* buf, uint32_t* length);
 
 const char*           regfi_type_val2str(unsigned int val);
@@ -977,20 +1173,25 @@
 char*                 regfi_get_group(WINSEC_DESC* sec_desc);
 
-REGFI_SUBKEY_LIST*    regfi_merge_subkeylists(uint16 num_lists, 
+REGFI_SUBKEY_LIST*    regfi_merge_subkeylists(uint16_t num_lists, 
 					      REGFI_SUBKEY_LIST** lists,
 					      bool strict);
-REGFI_SUBKEY_LIST*    regfi_load_subkeylist_aux(REGFI_FILE* file, uint32 offset,
-						uint32 max_size, bool strict,
-						uint8 depth_left);
-void                  regfi_add_message(REGFI_FILE* file, uint16 msg_type, 
+REGFI_SUBKEY_LIST*    regfi_load_subkeylist_aux(REGFI_FILE* file, uint32_t offset,
+						uint32_t max_size, bool strict,
+						uint8_t depth_left);
+void                  regfi_add_message(REGFI_FILE* file, uint16_t msg_type, 
 					const char* fmt, ...);
 REGFI_NK_REC*         regfi_copy_nk(const REGFI_NK_REC* nk);
 REGFI_VK_REC*         regfi_copy_vk(const REGFI_VK_REC* vk);
-int32                 regfi_calc_maxsize(REGFI_FILE* file, uint32 offset);
-int32                 regfi_conv_charset(const char* input_charset, 
+int32_t               regfi_calc_maxsize(REGFI_FILE* file, uint32_t offset);
+int32_t               regfi_conv_charset(const char* input_charset, 
 					 const char* output_charset,
-					 uint8* input, char* output, 
-					 uint32 input_len, uint32 output_max);
+					 uint8_t* input, char* output, 
+					 uint32_t input_len, uint32_t output_max);
 REGFI_DATA*           regfi_buffer_to_data(REGFI_BUFFER raw_data);
 
+/* XXX: move to base API and document */
+void                  regfi_unix2nt_time(REGFI_NTTIME* nt, time_t t);
+time_t                regfi_nt2unix_time(const REGFI_NTTIME* nt);
+
+
 #endif	/* _REGFI_H */
Index: /trunk/include/talloc.h
===================================================================
--- /trunk/include/talloc.h	(revision 167)
+++ /trunk/include/talloc.h	(revision 168)
@@ -33,5 +33,12 @@
 #include <string.h>
 #include <stdbool.h>
-#include "smb_deps.h" /* MAX macro */
+
+#ifndef MAX
+#define MAX(a,b) ((a)>(b)?(a):(b))
+#endif
+
+#ifndef MIN
+#define MIN(a,b) ((a)<(b)?(a):(b))
+#endif
 
 /*
Index: /trunk/include/void_stack.h
===================================================================
--- /trunk/include/void_stack.h	(revision 167)
+++ /trunk/include/void_stack.h	(revision 168)
@@ -1,3 +1,5 @@
-/*
+/**
+ * @file
+ *
  * Copyright (C) 2005,2007,2009 Timothy D. Morgan
  *
Index: /trunk/include/winsec.h
===================================================================
--- /trunk/include/winsec.h	(revision 167)
+++ /trunk/include/winsec.h	(revision 168)
@@ -1,3 +1,3 @@
-/*
+/** @file
  * This file contains refactored Samba code used to interpret Windows
  * Security Descriptors. See:
@@ -41,6 +41,6 @@
 #include <unistd.h>
 
-#include "smb_deps.h"
 #include "talloc.h"
+#include "byteorder.h"
 
 
@@ -72,9 +72,9 @@
 typedef struct _winsec_uuid
 {
-       uint32 time_low;
-       uint16 time_mid;
-       uint16 time_hi_and_version;
-       uint8  clock_seq[2];
-       uint8  node[6];
+       uint32_t time_low;
+       uint16_t time_mid;
+       uint16_t time_hi_and_version;
+       uint8_t  clock_seq[2];
+       uint8_t  node[6];
 } WINSEC_UUID;
 
Index: /trunk/lib/Makefile
===================================================================
--- /trunk/lib/Makefile	(revision 167)
+++ /trunk/lib/Makefile	(revision 168)
@@ -3,5 +3,5 @@
 ################################################################################
 
-FILES=regfi.o smb_deps.o winsec.o void_stack.o range_list.o lru_cache.o talloc.o
+FILES=regfi.o winsec.o void_stack.o range_list.o lru_cache.o talloc.o
 
 all: $(FILES)
@@ -9,7 +9,4 @@
 regfi.o: regfi.c
 	$(CC) $(CFLAGS) $(OPTS) $(INC) -c -o $@ regfi.c
-
-smb_deps.o: smb_deps.c
-	$(CC) $(CFLAGS) $(OPTS) $(INC) -c -o $@ smb_deps.c
 
 winsec.o: winsec.c
Index: /trunk/lib/lru_cache.c
===================================================================
--- /trunk/lib/lru_cache.c	(revision 167)
+++ /trunk/lib/lru_cache.c	(revision 168)
@@ -1,3 +1,5 @@
-/*
+/**
+ * @file
+ *
  * Copyright (C) 2008-2009 Timothy D. Morgan
  *
Index: /trunk/lib/range_list.c
===================================================================
--- /trunk/lib/range_list.c	(revision 167)
+++ /trunk/lib/range_list.c	(revision 168)
@@ -1,3 +1,5 @@
-/*
+/**
+ * @file
+ *
  * Copyright (C) 2008-2009 Timothy D. Morgan
  *
